"use strict";
exports.__esModule = true;
var Is = /** @class */ (function () {
    function Is() {
    }
    Is.callToString = function (arg) {
        return Object.prototype.toString.call(arg);
    };
    Is.$string = function (arg) {
        return Is.callToString(arg) === '[object String]';
    };
    Is.is = function (arg, type) {
        var response = false;
        if (Is.$string(type))
            response = Is.callToString(arg) === "[object " + type + "]";
        else if (Is.$function(type))
            response = arg instanceof type;
        return response;
    };
    Is.$array = function (arg) {
        return Is.is(arg, 'Array');
    };
    Is.$null = function (arg) {
        return Is.is(arg, 'Null');
    };
    Is.$number = function (arg) {
        return Is.is(arg, 'Number');
    };
    Is.$object = function (arg) {
        return Is.is(arg, 'Object');
    };
    Is.$undefined = function (arg) {
        return Is.is(arg, 'Undefined');
    };
    Is.$boolean = function (arg) {
        return Is.is(arg, 'Boolean');
    };
    Is.$function = function (arg) {
        return Is.callToString(arg) === '[object Function]';
    };
    Is.isValidObject = function (data, rules) {
        if (!Is.$object(data))
            throw new Error('The data parameter must be an Object');
        if (!Is.$object(rules))
            throw new Error('The rules parameter must be an Object');
        var $response = true;
        var $keys = Object.getOwnPropertyNames(rules);
        for (var _i = 0, $keys_1 = $keys; _i < $keys_1.length; _i++) {
            var key = $keys_1[_i];
            if (!$response)
                break;
            var rule = rules[key];
            if (Is.$array(rule)) {
                if (rule.length < 1)
                    continue;
                var parcial = false;
                for (var _a = 0, rule_1 = rule; _a < rule_1.length; _a++) {
                    var _rule = rule_1[_a];
                    if (parcial)
                        break;
                    parcial = parcial || Is.is(data[key], _rule);
                }
                $response = $response && parcial;
            }
            else
                $response = $response && Is.is(data[key], rule);
        }
        return $response;
    };
    return Is;
}());
exports["default"] = Is;
